#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/wait.h>

int main(int argc, char *argv[]) {
	pid_t retval;
	int fdshared;
	int fdprivate;
	fdshared = open("/tmp/fdshared", O_WRONLY | O_CREAT | O_TRUNC, 0666);
	switch (retval = fork()) {
		case 0: {
							fdprivate = open("/tmp/fdprivate", O_WRONLY | O_CREAT, 0666);
							write(fdshared, "ciaoneone ", 10);
							write(fdprivate, "ciaoneone ", 10);
						}
						break;
		default: {
							 int wstatus;
							 fdprivate = open("/tmp/fdprivate", O_WRONLY | O_CREAT, 0666);
							 sleep(1);
							 write(fdshared, "kitty ", 6);
							 write(fdprivate, "kitty ", 6);
							 waitpid(-1, &wstatus, 0);
						 }
			break;
		case -1:
			perror("fork");
			break;
	}
}
