#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>

void clean1(void) {
	printf("clean1\n");
}

void clean2(void) {
	printf("clean2\n");
}

extern char **environ;

int main(int argc, char *argv[]) {
	pid_t retval;
	int fdout;
	switch (retval = fork()) {
		case 0: {
							char *lsargv[] = {"ls", "-l", NULL};
							fdout = open(argv[1], O_WRONLY | O_CREAT | O_TRUNC, 0666);
							dup2(fdout, 1);
							close(fdout);
							execve("/bin/ls", lsargv, environ);
							printf("i'm here!\n");
						}
						break;
		default: {
							 int wstatus;
							 waitpid(-1, &wstatus, 0);
							 printf("%d\n", WEXITSTATUS(wstatus));
						 }
			break;
		case -1:
			perror("fork");
			break;
	}
}
