#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>

int main(int argc, char *argv[]) {
	int fdin;
	int fdout;
	int n;
	int bufsize;
	if (argc != 4) {
		fprintf(stderr, "Usage: %s src dest bufsize\n",argv[0]);
		exit(1);
	}
	fdin = open(argv[1], O_RDONLY);
	if (fdin  < 0) {
		perror("source file");
		exit(1);
	}
	fdout = open(argv[2], O_WRONLY | O_CREAT | O_EXCL, 0666);
	if (fdout  < 0) {
		perror("destination file");
		exit(1);
	}
	bufsize = atoi(argv[3]);
	char buf[bufsize];
	while ((n = read(fdin, buf, bufsize)) > 0)
		write(fdout, buf, n);
	close(fdin);
	close(fdout);
}
